package src;

import java.util.concurrent.Semaphore;

public class Arbitrator {
    private final Semaphore semaphore;

    public Arbitrator(int maxPhilosophers) {
        this.semaphore = new Semaphore(maxPhilosophers - 1);  // Allow up to N-1 philosophers to eat
    }

    public void requestPermission(Philosopher philosopher) throws InterruptedException {
        semaphore.acquire();  // Request permission to eat
    }

    public void releasePermission(Philosopher philosopher) {
        semaphore.release();  // Release permission after eating
    }
}
