package src;

public class Chopstick {
    private boolean inUse = false;

    // Ein Philosophen-Thread nimmt das Stäbchen
    public synchronized void pickUp() throws InterruptedException {
        while (inUse) {
            wait();  // Warten, bis das Stäbchen verfügbar ist
        }
        inUse = true;
    }

    // Ein Philosophen-Thread legt das Stäbchen wieder zurück
    public synchronized void putDown() {
        inUse = false;
        notifyAll();  // Andere wartende Philosophen benachrichtigen
    }
}

