package pp;

public class Runner {

    public static void main(String... args) {
        var task = new Task();
        var thread = new Thread(task);
        thread.setUncaughtExceptionHandler((t, e) -> {
            System.err.println("Unhandled Exception: " + e.getMessage());
            System.err.println(" Thread: " + t.threadId() + " - " + t.getName());
            System.err.println(" Thread State: " + t.getState());
            e.printStackTrace(System.err);
        });
        thread.start();
        // falsch: thread läuft weiter:
        // (new Thread(() -> thread.interrupt())).start();

        // richtig: thread wird beendet:
        (new Thread(() -> task.stopRequest())).start();
    }
}
