package pp;

public class MemoryBarrierTest1b extends Thread {

    private boolean stopped = false;

    // lesende Zugriffe auf this.stopped über synchronized Getter => wirkt als
    // Memory-Barrier (Pull)
    public synchronized boolean getStopped() {
        return this.stopped;
    }

    // ändernde Zugriffe auf this.stopped über synchronized Setter => wirkt als
    // Memory-Barrier (Push)
    public synchronized void setStopped(boolean stopped) {
        this.stopped = stopped;
    }

    @Override
    public void run() {
        while (!getStopped()) {
            // work
        }
        System.out.println("MemoryBarrierTest-Thread actually stopped.");
    }

    public static void main(String... args) throws InterruptedException {
        var t = new MemoryBarrierTest1b();
        t.start();
        Thread.sleep(1000);
        t.setStopped(true);
        System.out.println("Main thread set stopped on MemoryBarrierTest-Thread.");
    }
}
