package pp;

public class RunnableWithResult1<T> extends RunnableWithResult<T> {
    private T result;
    private boolean finished;

    public RunnableWithResult1(Expression<T> expr) {
        super(expr);
    }

    @Override
    public void run() {
        synchronized (this) { // Memorybarrier
            this.finished = false;
        }
        this.result = expr().eval();
        synchronized (this) {
            this.finished = true;
        } // Memorybarrier
    }

    @Override
    public synchronized Boolean isAvailable() {
        return this.finished;
    }

    @Override
    public synchronized T get() {
        return this.result;
    }
}
