package pp;

public class RunnableWithResult2<T> extends RunnableWithResult<T> {
    private T result;
    private volatile Thread self;

    public RunnableWithResult2(Expression<T> expr) {
        super(expr);
    }

    @Override
    public void run() {
        this.self = Thread.currentThread();
        this.result = expr().eval();
    }

    @Override
    public synchronized Boolean isAvailable() {
        return (this.self != null) && !this.self.isAlive();
    }

    @Override
    public synchronized T get() {
        return this.result;
    }
}
