package pp;

public class RunnableWithResult3<T> extends RunnableWithResult<T> {
    private T result;
    private Thread executor;

    public RunnableWithResult3(Expression<T> expr) {
        super(expr);
        this.executor = new Thread(this);
        this.executor.start();
    }

    @Override
    public void run() {
        this.result = expr().eval();
    }

    @Override
    public synchronized Boolean isAvailable() {
        return (this.executor != null) && !this.executor.isAlive();
    }

    @Override
    public synchronized T get() {
        return this.result;
    }
}
