package pp;

import java.util.concurrent.Executors;
import java.util.concurrent.TimeUnit;

public class TaskInnerClass {

    private static final int NUMBER_OF_TASKS = 20;

    public static void main(String... args) {
        var pool1 = FixedRunner.test(new Runnable() {
            @Override
            public void run() {
                System.out.println(Thread.currentThread().getName());
            }
        }, NUMBER_OF_TASKS);
        var pool2 = CachedRunner.test(new Runnable() {
            @Override
            public void run() {
                System.out.println(Thread.currentThread().getName());
            }
        }, NUMBER_OF_TASKS);
        var scheduler = Executors.newSingleThreadScheduledExecutor();
        scheduler.schedule(new Runnable() {
            @Override
            public void run() {
                pool1.shutdown();
                pool2.shutdown();
                scheduler.shutdown();
            }
        }, 5, TimeUnit.SECONDS);
    }

}
