package pp;

import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.TimeUnit;

public class TaskStaticClass implements Runnable {
    static class Shutdowner implements Runnable {
        @Override
        public void run() {
            pool1.shutdown();
            pool2.shutdown();
            scheduler.shutdown();
        }
    }

    private static final int NUMBER_OF_TASKS = 20;
    private static ExecutorService pool1;
    private static ExecutorService pool2;
    private static ScheduledExecutorService scheduler;

    @Override
    public void run() {
        System.out.println(Thread.currentThread().getName());
    }

    public static void main(String... args) {
        pool1 = FixedRunner.test(new TaskStaticClass(),
                NUMBER_OF_TASKS);
        pool2 = CachedRunner.test(new TaskStaticClass(),
                NUMBER_OF_TASKS);
        scheduler = Executors.newSingleThreadScheduledExecutor();
        scheduler.schedule(new Shutdowner(), 5, TimeUnit.SECONDS);
    }

}
