package pp;

import java.util.concurrent.atomic.AtomicInteger;

class AtomicCounter1 implements ICounter {
    private final AtomicInteger c;

    public AtomicCounter1(int init) {
        this.c = new AtomicInteger(init);
    }

    @Override
    public void inc() {
        var temp = this.c.get();
        while (!this.c.compareAndSet(temp, temp + 1)) {
            temp = this.c.get();
        }
    }

    @Override
    public void dec() {
        var temp = this.c.get();
        while (!this.c.compareAndSet(temp, temp - 1)) {
            temp = this.c.get();
        }
    }

    @Override
    public int get() {
        return this.c.get();
    }
}
