package pp;

import java.util.concurrent.atomic.AtomicInteger;

class AtomicCounter3 implements ICounter {
    private final AtomicInteger c;

    public AtomicCounter3(int init) {
        this.c = new AtomicInteger(init);
    }

    @Override
    public void inc() {
        for (;;) {
            var current = this.c.get();
            var next = current + 1;
            if (this.c.compareAndSet(current, next)) {
                break;
            }
        }
    }

    @Override
    public void dec() {
        for (;;) {
            var current = this.c.get();
            var next = current - 1;
            if (this.c.compareAndSet(current, next)) {
                break;
            }
        }
    }

    @Override
    public int get() {
        return this.c.get();
    }
}
